//
// Created by robin on 10/8/17.
//

#ifndef NFC_CPPTOOLS_FREEFARETAGCLASSIC_H
#define NFC_CPPTOOLS_FREEFARETAGCLASSIC_H

#include "FreeFareTag.h"

namespace LibNfc
{
namespace FreeFare
{

class FreeFareTagClassicInternal;

struct FreeFareTagClassicMappingProgress
{
    int32_t done;
    int32_t total;
};

struct FreeFareTagClassicReadProgress
{
    int32_t done;
    int32_t total;
};

struct FreeFareTagClassicWriteProgress
{
    int32_t done;
    int32_t total;
};

class FreeFareTagClassic : public FreeFareTag
{
public:
    explicit FreeFareTagClassic(std::shared_ptr<FreeFareTagClassicInternal> tag);

    LibNfc::Utils::ResultBool authenticate(int sector, const std::string& key, int keyType);

    LibNfc::Utils::Result<MappedKeys> mapKeys(const std::vector<std::string>& keys,
                                              std::function<void(FreeFareTagClassicMappingProgress)> mapCb = nullptr);

    LibNfc::Utils::ResultString readBlock(int sector, int block, const std::string& key, int keyType);

    LibNfc::Utils::Result<FreeFareClassicSector> readSector(int sector, const std::string& key, int keyType);

    LibNfc::Utils::Result<std::vector<FreeFareClassicSector>> read(const MappedKeys& keys,
                                                            std::function<void(FreeFareTagClassicReadProgress)> readCb = nullptr);

    LibNfc::Utils::Result<std::vector<FreeFareClassicSector>> read(const std::vector<std::string>& keys,
                                                            std::function<void(FreeFareTagClassicMappingProgress)> mapCb = nullptr,
                                                            std::function<void(FreeFareTagClassicReadProgress)> readCb = nullptr);

    LibNfc::Utils::ResultBool writeBlock(int sector,
                                         int block,
                                         const std::string& key,
                                         int keyType,
                                         const std::string& data);

    LibNfc::Utils::ResultBool writeSector(int sector, const std::string& key, int keyType, const std::string& data);

    LibNfc::Utils::ResultBool write(const MappedKeys& keys,
                                    const std::string& data,
                                    bool writeSector0,
                                    std::function<void(FreeFareTagClassicWriteProgress)> writeCb = nullptr);

    LibNfc::Utils::ResultBool write(const std::vector<std::string>& keys,
                                    const std::string& data,
                                    bool writeSector0,
                                    std::function<void(FreeFareTagClassicMappingProgress)> mapCb = nullptr,
                                    std::function<void(FreeFareTagClassicWriteProgress)> writeCb = nullptr);
};

}; // FreeFare
}; // LibNfc

#endif //NFC_CPPTOOLS_FREEFARETAGCLASSIC_H
